"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _appDemoRestClient = require("./appDemoRestClient");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var constants = require('../../commons/constants');

var DemoAppConfig =
/*#__PURE__*/
function (_React$Component) {
  _inherits(DemoAppConfig, _React$Component);

  function DemoAppConfig() {
    _classCallCheck(this, DemoAppConfig);

    return _possibleConstructorReturn(this, _getPrototypeOf(DemoAppConfig).apply(this, arguments));
  }

  _createClass(DemoAppConfig, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      window.addEventListener("message", this.handleReceiveMessage, false);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      window.removeEventListener("message", this.handleReceiveMessage);
    }
  }, {
    key: "handleReceiveMessage",
    value: function handleReceiveMessage(event) {
      var message = event.data;

      if (message) {
        var type = message.type;

        if (type === constants.WEBCODESK_MESSAGE_GET_DECLARATIONS_WITH_ETC) {
          var result = {};
          (0, _appDemoRestClient.get)('/etcFiles.json').then(function (data) {
            result.etcFiles = data;
            return (0, _appDemoRestClient.get)('/declarationFiles.json');
          }).then(function (data) {
            result.declarationFiles = data;
            window.parent.postMessage({
              type: constants.FRAMEWORK_MESSAGE_DECLARATIONS_WITH_ETC,
              payload: result
            }, '*');
          }).catch(function (error) {
            window.parent.postMessage({
              type: 'error',
              payload: error.message
            }, '*');
            console.error(error);
          });
        } else if (type === constants.WEBCODESK_MESSAGE_GET_DECLARATIONS) {
          var _result = {};
          (0, _appDemoRestClient.get)('/declarationFiles.json').then(function (data) {
            _result.declarationFiles = data;
            window.parent.postMessage({
              type: constants.FRAMEWORK_MESSAGE_DECLARATIONS,
              payload: _result
            }, '*');
          }).catch(function (error) {
            window.parent.postMessage({
              type: 'error',
              payload: error.message
            }, '*');
            console.error(error);
          });
        }
      }
    }
  }, {
    key: "render",
    value: function render() {
      return null;
    }
  }]);

  return DemoAppConfig;
}(_react.default.Component);

var _default = DemoAppConfig;
exports.default = _default;