"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _isEqual = _interopRequireDefault(require("lodash/isEqual"));

var _react = _interopRequireWildcard(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _utilities = require("./utilities");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var style = {
  width: '100%',
  height: '100%',
  display: 'flex',
  alignItems: 'center',
  justifyContent: 'center',
  position: 'relative'
};
var preStyle = {
  margin: '1em'
};
var shadowStyle = {
  position: 'absolute',
  top: 0,
  right: 0,
  bottom: 0,
  left: 0,
  borderRadius: '4px',
  border: '1px dashed #dddddd',
  zIndex: 5
};
var shadowStyleAccepting = {
  position: 'absolute',
  top: 0,
  right: 0,
  bottom: 0,
  left: 0,
  borderRadius: '4px',
  backgroundColor: '#76FF03',
  zIndex: 5,
  opacity: 0.3
};
var shadowStyleAcceptable = {
  position: 'absolute',
  top: 0,
  right: 0,
  bottom: 0,
  left: 0,
  borderRadius: '4px',
  border: '1px dashed #FFC107',
  zIndex: 5
};

var ComponentWrapper =
/*#__PURE__*/
function (_Component) {
  _inherits(ComponentWrapper, _Component);

  function ComponentWrapper(props) {
    var _this;

    _classCallCheck(this, ComponentWrapper);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ComponentWrapper).call(this, props));
    _this.state = {
      isDragOver: false,
      isItemAccepting: false
    };
    _this.initDOMNode = _this.initDOMNode.bind(_assertThisInitialized(_this));
    _this.handleMouseDown = _this.handleMouseDown.bind(_assertThisInitialized(_this));
    _this.handleContextMenu = _this.handleContextMenu.bind(_assertThisInitialized(_this));
    _this.handleMouseOver = _this.handleMouseOver.bind(_assertThisInitialized(_this));
    _this.handleMouseOut = _this.handleMouseOut.bind(_assertThisInitialized(_this));
    _this.handleNoop = _this.handleNoop.bind(_assertThisInitialized(_this));
    _this.handleDragEnter = _this.handleDragEnter.bind(_assertThisInitialized(_this));
    _this.handleDragLeave = _this.handleDragLeave.bind(_assertThisInitialized(_this));
    _this.handleDrop = _this.handleDrop.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(ComponentWrapper, [{
    key: "initDOMNode",
    value: function initDOMNode() {
      this.$DOMNode = _reactDom.default.findDOMNode(this);

      if (this.$DOMNode) {
        this.$DOMNode.addEventListener('mousedown', this.handleMouseDown, false);
        this.$DOMNode.addEventListener('mouseover', this.handleMouseOver, false);
        this.$DOMNode.addEventListener('mouseout', this.handleMouseOut, false);
        this.$DOMNode.addEventListener('click', this.handleNoop, false);
        this.$DOMNode.addEventListener('doubleclick', this.handleNoop, false);
        this.$DOMNode.addEventListener('mouseup', this.handleNoop, false);
        this.$DOMNode.addEventListener('contextmenu', this.handleContextMenu, false);
      }
    }
  }, {
    key: "clearDOMNode",
    value: function clearDOMNode() {
      if (this.$DOMNode) {
        this.$DOMNode.removeEventListener('mousedown', this.handleMouseDown);
        this.$DOMNode.removeEventListener('mouseover', this.handleMouseOver);
        this.$DOMNode.removeEventListener('mouseout', this.handleMouseOut);
        this.$DOMNode.removeEventListener('click', this.handleNoop);
        this.$DOMNode.removeEventListener('doubleclick', this.handleNoop);
        this.$DOMNode.removeEventListener('mouseup', this.handleNoop);
        this.$DOMNode.removeEventListener('contextmenu', this.handleContextMenu);
      }

      this.$DOMNode = undefined;
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.initDOMNode();
      var _this$props = this.props,
          elementKey = _this$props.elementKey,
          onComponentInstanceInitialize = _this$props.onComponentInstanceInitialize;

      if (onComponentInstanceInitialize) {
        onComponentInstanceInitialize(elementKey, this);
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState, snapshot) {
      var _this$props2 = this.props,
          draggedItem = _this$props2.draggedItem,
          draggedItemPosition = _this$props2.draggedItemPosition,
          wrappedComponent = _this$props2.wrappedComponent;

      if (!wrappedComponent) {
        if (draggedItem && draggedItemPosition && (!prevProps.draggedItemPosition || draggedItemPosition !== prevProps.draggedItemPosition && !(0, _isEqual.default)(draggedItemPosition, prevProps.draggedItemPosition))) {
          var pos = this.$DOMNode.getBoundingClientRect();

          if (draggedItemPosition.top > pos.top && draggedItemPosition.top < pos.bottom && draggedItemPosition.left > pos.left && draggedItemPosition.left < pos.right) {
            this.handleDragEnter();
          } else {
            this.handleDragLeave();
          }
        } else if (!draggedItem && !draggedItemPosition && prevProps.draggedItem && prevProps.draggedItemPosition) {
          this.handleDrop();
        }
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.clearDOMNode();
      var _this$props3 = this.props,
          elementKey = _this$props3.elementKey,
          onComponentInstanceDestroy = _this$props3.onComponentInstanceDestroy;

      if (onComponentInstanceDestroy) {
        onComponentInstanceDestroy(elementKey, this);
      }
    }
  }, {
    key: "selectComponent",
    value: function selectComponent() {
      var elementKey = this.props.elementKey;

      if ((0, _utilities.isVisible)(this.$DOMNode)) {
        window.dispatchEvent(new CustomEvent('selectComponentWrapper', {
          detail: {
            elementKey: elementKey,
            domNode: this.$DOMNode
          }
        }));
      }
    }
  }, {
    key: "handleMouseDown",
    value: function handleMouseDown(e) {
      e.stopPropagation();
      e.preventDefault();
      var _this$props4 = this.props,
          elementKey = _this$props4.elementKey,
          onMouseDown = _this$props4.onMouseDown;

      if (onMouseDown) {
        onMouseDown(elementKey);
      }
    }
  }, {
    key: "handleContextMenu",
    value: function handleContextMenu(e) {
      e.stopPropagation();
      e.preventDefault();
      var _this$props5 = this.props,
          elementKey = _this$props5.elementKey,
          onContextMenuClick = _this$props5.onContextMenuClick;

      if (onContextMenuClick) {
        onContextMenuClick(elementKey);
      }
    }
  }, {
    key: "handleMouseOver",
    value: function handleMouseOver(e) {
      var elementKey = this.props.elementKey;
      window.dispatchEvent(new CustomEvent('mouseOverComponentWrapper', {
        detail: {
          elementKey: elementKey,
          domNode: this.$DOMNode
        }
      }));
    }
  }, {
    key: "handleMouseOut",
    value: function handleMouseOut(e) {
      var elementKey = this.props.elementKey;
      window.dispatchEvent(new CustomEvent('mouseOutComponentWrapper', {
        detail: {
          elementKey: elementKey,
          domNode: this.$DOMNode,
          remove: true
        }
      }));
    }
  }, {
    key: "handleDragEnter",
    value: function handleDragEnter() {
      var draggedItem = this.props.draggedItem;

      if (draggedItem) {
        this.setState({
          isItemAccepting: true,
          isDragOver: true
        });
      }
    }
  }, {
    key: "handleDragLeave",
    value: function handleDragLeave() {
      this.setState({
        isItemAccepting: false,
        isDragOver: false
      });
    }
  }, {
    key: "handleDrop",
    value: function handleDrop() {
      var _this$props6 = this.props,
          elementKey = _this$props6.elementKey,
          itemWasDropped = _this$props6.itemWasDropped,
          draggedItem = _this$props6.draggedItem;
      var _this$state = this.state,
          isItemAccepting = _this$state.isItemAccepting,
          isDragOver = _this$state.isDragOver;

      if (isItemAccepting && isDragOver && itemWasDropped) {
        itemWasDropped({
          destination: {
            key: elementKey
          },
          source: draggedItem
        });
        this.setState({
          isItemAccepting: false,
          isDragOver: false
        });
      }
    }
  }, {
    key: "handleNoop",
    value: function handleNoop(e) {
      e.stopPropagation();
      e.preventDefault();
    }
  }, {
    key: "renderDropZone",
    value: function renderDropZone() {
      var _this$props7 = this.props,
          elementKey = _this$props7.elementKey,
          draggedItem = _this$props7.draggedItem;
      var isItemAccepting = this.state.isItemAccepting;
      var style = shadowStyle;

      if (isItemAccepting) {
        style = shadowStyleAccepting;
      } else if (draggedItem) {
        style = shadowStyleAcceptable;
      }

      return _react.default.createElement("div", {
        key: "DropZone".concat(elementKey),
        style: style
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props8 = this.props,
          elementKey = _this$props8.elementKey,
          wrappedComponent = _this$props8.wrappedComponent,
          wrappedProps = _this$props8.wrappedProps,
          children = _this$props8.children;

      if (!wrappedComponent) {
        return _react.default.createElement("div", {
          key: elementKey,
          style: style
        }, _react.default.createElement("div", null, _react.default.createElement("pre", {
          style: preStyle
        }, _react.default.createElement("code", null, "\u2295"))), this.renderDropZone());
      }

      return _react.default.createElement(wrappedComponent, wrappedProps, children);
    }
  }]);

  return ComponentWrapper;
}(_react.Component);

var _default = ComponentWrapper;
exports.default = _default;