"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _get = _interopRequireDefault(require("lodash/get"));

var _cloneDeep = _interopRequireDefault(require("lodash/cloneDeep"));

var _isArray = _interopRequireDefault(require("lodash/isArray"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _queryString = _interopRequireDefault(require("query-string"));

var _ComponentWrapper = _interopRequireDefault(require("./ComponentWrapper"));

var _NotFoundComponent = _interopRequireDefault(require("../NotFoundComponent"));

var mouseOverBoundaries = _interopRequireWildcard(require("./mouseOverBoundaries"));

var selectedBoundaries = _interopRequireWildcard(require("./selectedBoundaries"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var constants = require('../../commons/constants');

function sendMessage(message) {
  if (message) {
    window.parent.postMessage(message, '*');
  }
} // ToDo: remove once the WebpackDevServer fixes HMR - it should preserve React components state (now it does not)
// https://github.com/webpack/webpack-dev-server/issues/1377
// https://github.com/gaearon/react-hot-loader/issues/934


var storeComponentsTree;
var selectedKeys = [];

var renderComponent = function renderComponent(userComponents, description, serviceComponentOptions, rootProps) {
  if (description) {
    var type = description.type,
        key = description.key,
        props = description.props,
        children = description.children;

    if (!type || !props) {
      return rootProps;
    }

    var componentName = props.componentName,
        propertyName = props.propertyName,
        propertyValue = props.propertyValue,
        isSelected = props.isSelected;

    if (isSelected) {
      selectedKeys.push(key);
    }

    if (type === constants.COMPONENT_PROPERTY_ELEMENT_TYPE) {
      var placeholderProps = _objectSpread({
        key: key,
        elementKey: key,
        elementProperty: propertyName,
        isSelected: isSelected
      }, serviceComponentOptions);

      var newElement = _react.default.createElement(_ComponentWrapper.default, placeholderProps);

      if (rootProps) {
        if (propertyName) {
          rootProps[propertyName] = newElement;
        } else {
          if (rootProps.push) {
            rootProps.push(newElement);
          } else {
            console.error('It seems that you missed propertyName in the page component target in the page config.');
          }
        }
      } else {
        // only placeholder component can be the root element
        rootProps = newElement;
      }
    } else if (type === constants.PAGE_COMPONENT_TYPE || type === constants.PAGE_NODE_TYPE) {
      var _newElement;

      var component = (0, _get.default)(userComponents, componentName, null);

      if (component) {
        var propsComponent = {};

        if (children && children.length > 0) {
          children.forEach(function (child) {
            propsComponent = renderComponent(userComponents, child, serviceComponentOptions, propsComponent);
          });
        }

        var nestedComponents = [];

        if (propsComponent.children && (0, _isArray.default)(propsComponent.children)) {
          nestedComponents = propsComponent.children;
          delete propsComponent.children;
        }

        var wrapperProps = _objectSpread({
          key: key,
          elementKey: key,
          wrappedProps: propsComponent,
          wrappedComponent: component,
          isSelected: isSelected
        }, serviceComponentOptions);

        _newElement = _react.default.createElement(_ComponentWrapper.default, wrapperProps, nestedComponents);
      } else {
        _newElement = _react.default.createElement(_NotFoundComponent.default, {
          componentName: componentName
        });
      }

      if (rootProps) {
        if (propertyName) {
          // component assigned to some named property in the
          rootProps[propertyName] = _newElement;
        } else {
          if (rootProps.push) {
            rootProps.push(_newElement);
          } else {
            console.error('It seems that you missed propertyName in the page component target in the page config.');
          }
        }
      } else {
        // only page component can be the root element
        rootProps = _newElement;
      }
    } else if (type === constants.COMPONENT_PROPERTY_ARRAY_TYPE || type === constants.COMPONENT_PROPERTY_OBJECT_TYPE) {
      if (rootProps) {
        if (propertyName) {
          if (propertyValue) {
            rootProps[propertyName] = (0, _cloneDeep.default)(propertyValue);
          } else {
            rootProps[propertyName] = propertyValue;
          }
        } else {
          if (typeof propertyValue !== 'undefined') {
            rootProps.push((0, _cloneDeep.default)(propertyValue));
          }
        }
      }
    } else if (type === constants.COMPONENT_PROPERTY_SHAPE_TYPE) {
      var newObject = {};

      if (children && children.length > 0) {
        children.forEach(function (child) {
          newObject = renderComponent(userComponents, child, serviceComponentOptions, newObject);
        });
      }

      if (rootProps) {
        if (propertyName) {
          rootProps[propertyName] = newObject;
        } else {
          if (rootProps.push) {
            rootProps.push(newObject);
          } else {
            console.error('It seems that you missed propertyName in the page component target in the page config.');
          }
        }
      }
    } else if (type === constants.COMPONENT_PROPERTY_ARRAY_OF_TYPE) {
      var newArrayModel = [];

      if (children && children.length > 0) {
        children.forEach(function (child) {
          newArrayModel = renderComponent(userComponents, child, serviceComponentOptions, newArrayModel);
        });
      }

      if (rootProps) {
        if (propertyName) {
          rootProps[propertyName] = newArrayModel;
        } else {
          if (rootProps.push) {
            rootProps.push(newArrayModel);
          } else {
            console.error('It seems that you missed propertyName in the page component target in the page config.');
          }
        }
      }
    } else if (type === constants.COMPONENT_PROPERTY_STRING_TYPE || type === constants.COMPONENT_PROPERTY_ONE_OF_TYPE || type === constants.COMPONENT_PROPERTY_SYMBOL_TYPE || type === constants.COMPONENT_PROPERTY_BOOL_TYPE || type === constants.COMPONENT_PROPERTY_ANY_TYPE || type === constants.COMPONENT_PROPERTY_NUMBER_TYPE) {
      if (rootProps) {
        if (propertyName) {
          if (propertyName !== constants.COMPONENT_PROPERTY_DO_NOT_USE_IN_FLOWS_NAME) {
            rootProps[propertyName] = propertyValue;
          }
        } else {
          if (typeof propertyValue !== 'undefined') {
            if (rootProps.push) {
              rootProps.push(propertyValue);
            } else {
              console.error('It seems that you missed propertyName in the page component target in the page config.');
            }
          }
        }
      }
    }
  }

  return rootProps;
};

var PageComposer =
/*#__PURE__*/
function (_React$Component) {
  _inherits(PageComposer, _React$Component);

  function PageComposer(props) {
    var _this;

    _classCallCheck(this, PageComposer);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(PageComposer).call(this, props));
    _this.renderPage = _this.renderPage.bind(_assertThisInitialized(_this));
    _this.handleReceiveMessage = _this.handleReceiveMessage.bind(_assertThisInitialized(_this));
    _this.handleComponentInstanceInitialize = _this.handleComponentInstanceInitialize.bind(_assertThisInitialized(_this));
    _this.handleComponentInstanceDestroy = _this.handleComponentInstanceDestroy.bind(_assertThisInitialized(_this));
    _this.itemWasDropped = _this.itemWasDropped.bind(_assertThisInitialized(_this));
    _this.handleSelectCell = _this.handleSelectCell.bind(_assertThisInitialized(_this));
    _this.handleContextMenuClick = _this.handleContextMenuClick.bind(_assertThisInitialized(_this));
    _this.handleKeyDown = _this.handleKeyDown.bind(_assertThisInitialized(_this));
    _this.componentInstancesMap = {};
    _this.state = {
      componentsTree: storeComponentsTree || {},
      draggedItem: null,
      draggedItemPosition: null
    };
    return _this;
  }

  _createClass(PageComposer, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var paramsMap = _queryString.default.parse(window.location.search);

      if (paramsMap && paramsMap.iframeId) {
        this.iframeId = paramsMap.iframeId;
      }

      window.addEventListener("message", this.handleReceiveMessage, false);
      mouseOverBoundaries.initElements();
      selectedBoundaries.initElements();
      window.document.addEventListener('keydown', this.handleKeyDown);
      this.traverseComponentInstances();
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      window.removeEventListener("message", this.handleReceiveMessage);
      mouseOverBoundaries.destroyElements();
      selectedBoundaries.destroyElements();
      window.document.removeEventListener('keydown', this.handleKeyDown);
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState) {
      var _this$state = this.state,
          componentsTree = _this$state.componentsTree,
          draggedItem = _this$state.draggedItem,
          draggedItemPosition = _this$state.draggedItemPosition;
      return componentsTree !== nextState.componentsTree || draggedItem !== nextState.draggedItem || draggedItemPosition !== nextState.draggedItemPosition;
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState, snapshot) {
      var componentsTree = this.state.componentsTree;

      if (componentsTree !== prevState.componentsTree) {
        storeComponentsTree = componentsTree;
        this.traverseComponentInstances();
      }
    }
  }, {
    key: "traverseComponentInstances",
    value: function traverseComponentInstances() {
      var _this2 = this;

      if (selectedKeys && selectedKeys.length > 0) {
        selectedKeys.forEach(function (selectedKeyItem) {
          var componentRefs = _this2.componentInstancesMap[selectedKeyItem];

          if (componentRefs && componentRefs.length > 0) {
            componentRefs.forEach(function (componentInstance) {
              if (componentInstance && componentInstance.selectComponent) {
                componentInstance.selectComponent();
              }
            });
          }
        });
      } else {
        window.dispatchEvent(new CustomEvent('selectComponentWrapper', {
          detail: {
            domNode: null
          }
        }));
      }
    }
  }, {
    key: "handleComponentInstanceInitialize",
    value: function handleComponentInstanceInitialize(elementKey, componentRef) {
      this.componentInstancesMap[elementKey] = this.componentInstancesMap[elementKey] || [];
      this.componentInstancesMap[elementKey].push(componentRef);
    }
  }, {
    key: "handleComponentInstanceDestroy",
    value: function handleComponentInstanceDestroy(elementKey, componentRef) {
      var componentRefs = this.componentInstancesMap[elementKey];

      if (componentRefs) {
        if (componentRefs.length === 1) {
          delete this.componentInstancesMap[elementKey];
        } else if (componentRefs.length > 1) {
          var foundIndex = componentRefs.findIndex(function (i) {
            return i === componentRef;
          });

          if (foundIndex >= 0) {
            componentRefs.splice(foundIndex, 1);
            this.componentInstancesMap[elementKey] = componentRefs;
          }
        }
      }
    }
  }, {
    key: "handleReceiveMessage",
    value: function handleReceiveMessage(event) {
      var message = event.data;

      if (message) {
        var type = message.type,
            payload = message.payload,
            sourceId = message.sourceId;

        if (sourceId === this.iframeId) {
          if (type === constants.WEBCODESK_MESSAGE_UPDATE_PAGE_COMPONENTS_TREE) {
            this.setState({
              componentsTree: payload
            });
          } else if (type === constants.WEBCODESK_MESSAGE_COMPONENT_ITEM_DRAG_START) {
            this.setState({
              draggedItem: payload
            });
          } else if (type === constants.WEBCODESK_MESSAGE_COMPONENT_ITEM_DRAG_END) {
            this.setState({
              draggedItem: null,
              draggedItemPosition: null
            });
          } else if (type === constants.WEBCODESK_MESSAGE_COMPONENT_ITEM_DRAG_MOVE) {
            this.setState({
              draggedItemPosition: payload
            });
          } else if (type === constants.WEBCODESK_MESSAGE_DELETE_PAGE_COMPONENT) {
            window.dispatchEvent(new CustomEvent('selectComponentWrapper', {
              detail: {
                domNode: null
              }
            }));
          }
        }
      }
    }
  }, {
    key: "itemWasDropped",
    value: function itemWasDropped(testItem) {
      sendMessage({
        type: constants.FRAMEWORK_MESSAGE_COMPONENT_ITEM_WAS_DROPPED,
        payload: testItem,
        sourceId: this.iframeId
      });
    }
  }, {
    key: "handleSelectCell",
    value: function handleSelectCell(cellKey) {
      sendMessage({
        type: constants.FRAMEWORK_MESSAGE_PAGE_CELL_WAS_SELECTED,
        payload: {
          targetKey: cellKey
        },
        sourceId: this.iframeId
      });
    }
  }, {
    key: "handleContextMenuClick",
    value: function handleContextMenuClick(cellKey) {
      sendMessage({
        type: constants.FRAMEWORK_MESSAGE_CONTEXT_MENU_CLICKED,
        payload: {
          targetKey: cellKey
        },
        sourceId: this.iframeId
      });
    }
  }, {
    key: "handleKeyDown",
    value: function handleKeyDown(e) {
      if (e) {
        var keyCode = e.keyCode,
            metaKey = e.metaKey,
            ctrlKey = e.ctrlKey;

        if (metaKey || ctrlKey) {
          if (keyCode === 90) {
            // Undo
            sendMessage({
              type: constants.FRAMEWORK_MESSAGE_UNDO,
              sourceId: this.iframeId
            });
          } else if (keyCode === 67) {
            // Copy
            sendMessage({
              type: constants.FRAMEWORK_MESSAGE_COPY,
              sourceId: this.iframeId
            });
          } else if (keyCode === 86) {
            // Paste
            sendMessage({
              type: constants.FRAMEWORK_MESSAGE_PASTE,
              sourceId: this.iframeId
            });
          } else if (keyCode === 88) {
            // Cut
            sendMessage({
              type: constants.FRAMEWORK_MESSAGE_CUT,
              sourceId: this.iframeId
            });
          } else if (keyCode === 83) {
            // Save
            sendMessage({
              type: constants.FRAMEWORK_MESSAGE_SAVE,
              sourceId: this.iframeId
            });
          } else if (keyCode === 82) {
            // Reload
            sendMessage({
              type: constants.FRAMEWORK_MESSAGE_RELOAD,
              sourceId: this.iframeId
            });
          }
        } else {
          if (keyCode === 8 || keyCode === 46) {
            // Delete
            sendMessage({
              type: constants.FRAMEWORK_MESSAGE_DELETE,
              sourceId: this.iframeId
            });
          }
        }
      } // ctrl + z - Undo
      // 90 + metaKey || ctrlKey
      // ctrl + c - Copy
      // 67 + metaKey || ctrlKey
      // ctrl + v - Paste
      // 86 + metaKey || ctrlKey
      // ctrl + x - Cut
      // 88


      e.stopPropagation();
      e.preventDefault();
    }
  }, {
    key: "renderPage",
    value: function renderPage() {
      var userComponents = this.props.userComponents;
      var _this$state2 = this.state,
          componentsTree = _this$state2.componentsTree,
          draggedItem = _this$state2.draggedItem,
          draggedItemPosition = _this$state2.draggedItemPosition;
      selectedKeys = [];
      return renderComponent(userComponents, componentsTree, {
        itemWasDropped: this.itemWasDropped,
        draggedItem: draggedItem,
        draggedItemPosition: draggedItemPosition,
        onMouseDown: this.handleSelectCell,
        onContextMenuClick: this.handleContextMenuClick,
        onComponentInstanceInitialize: this.handleComponentInstanceInitialize,
        onComponentInstanceDestroy: this.handleComponentInstanceDestroy
      });
    }
  }, {
    key: "render",
    value: function render() {
      var content = this.renderPage();

      if (content) {
        return content;
      }

      return _react.default.createElement("span", null);
    }
  }]);

  return PageComposer;
}(_react.default.Component);

_defineProperty(PageComposer, "propTypes", {
  userComponents: _propTypes.default.object
});

_defineProperty(PageComposer, "defaultProps", {
  userComponents: {}
});

var _default = PageComposer;
exports.default = _default;