"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.pickReactElements = pickReactElements;
exports.default = createContainer;

var _cloneDeep = _interopRequireDefault(require("lodash/cloneDeep"));

var _isArray = _interopRequireDefault(require("lodash/isArray"));

var _isObject = _interopRequireDefault(require("lodash/isObject"));

var _react = _interopRequireDefault(require("react"));

var _reactRedux = require("react-redux");

var _redux = require("redux");

var _reselect = require("reselect");

var _selectors = _interopRequireDefault(require("../../store/selectors"));

var _actions = _interopRequireDefault(require("../../store/actions"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var sendDebugMessage = require('../../commons/sendMessage').default;

var constants = require('../../commons/constants');

function pickReactElements(obj2) {
  var obj1 = undefined;

  if (_react.default.isValidElement(obj2)) {
    obj1 = obj2;
  } else if ((0, _isArray.default)(obj2)) {
    var arrayItem;

    for (var i = 0; i < obj2.length; i++) {
      arrayItem = pickReactElements(obj2[i]);

      if (arrayItem) {
        obj1 = obj1 || [];
        obj1.push(arrayItem);
      }
    }
  } else if ((0, _isObject.default)(obj2)) {
    var objectField;

    for (var item in obj2) {
      if (obj2.hasOwnProperty(item)) {
        objectField = pickReactElements(obj2[item]);

        if (objectField) {
          obj1 = obj1 || {};
          obj1[item] = objectField;
        }
      }
    }
  }

  return obj1;
}

var Container =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Container, _React$Component);

  function Container(props, context) {
    var _this;

    _classCallCheck(this, Container);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Container).call(this, props, context));
    var _this$props = _this.props,
        componentName = _this$props.componentName,
        componentInstance = _this$props.componentInstance,
        componentKey = _this$props.componentKey;
    _this.wrappedHandlers = {};
    var _this$props2 = _this.props,
        containerEventHandlers = _this$props2.containerEventHandlers,
        actions = _this$props2.actions;

    if (containerEventHandlers && containerEventHandlers.length > 0) {
      containerEventHandlers.forEach(function (eventHandler) {
        _this.wrappedHandlers[eventHandler.name] = function () {
          var args = arguments;
          var handlerAction = actions[eventHandler.name];

          if (handlerAction) {
            if (window.__webcodeskIsListeningToFramework && window.__sendFrameworkMessage) {
              sendDebugMessage({
                key: componentKey,
                eventType: constants.DEBUG_MSG_COMPONENT_FIRE_EVENT,
                eventName: eventHandler.name,
                outputData: args && args.length > 0 ? (0, _cloneDeep.default)(args[0]) : undefined,
                componentName: componentName,
                componentInstance: componentInstance,
                timestamp: Date.now()
              });
            }

            handlerAction.apply(null, [args[0], args[1]]);
          } else {
            console.error("[Framework] Event handler was not found for ".concat(eventHandler.name, " event in ").concat(componentName, " instance ").concat(componentInstance));
          }
        };
      });
    }

    return _this;
  }

  _createClass(Container, [{
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState, nextContext) {
      if (nextProps.stateProps !== this.props.stateProps) {
        if (window.__webcodeskIsListeningToFramework && window.__sendFrameworkMessage) {
          var _this$props3 = this.props,
              componentName = _this$props3.componentName,
              componentInstance = _this$props3.componentInstance,
              componentKey = _this$props3.componentKey;
          sendDebugMessage({
            key: componentKey,
            eventType: constants.DEBUG_MSG_NEW_PROPS_EVENT,
            inputData: (0, _cloneDeep.default)(nextProps.stateProps),
            componentName: componentName,
            componentInstance: componentInstance,
            timestamp: Date.now()
          });
        }
      }

      return true;
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props4 = this.props,
          wrappedComponent = _this$props4.wrappedComponent,
          wrappedProps = _this$props4.wrappedProps,
          stateProps = _this$props4.stateProps,
          children = _this$props4.children;
      var elementsProps = pickReactElements(wrappedProps) || {};
      return _react.default.createElement(wrappedComponent, _objectSpread({}, wrappedProps, {}, this.wrappedHandlers, {}, stateProps, {}, elementsProps), children);
    }
  }]);

  return Container;
}(_react.default.Component);

var Component =
/*#__PURE__*/
function (_React$Component2) {
  _inherits(Component, _React$Component2);

  function Component() {
    _classCallCheck(this, Component);

    return _possibleConstructorReturn(this, _getPrototypeOf(Component).apply(this, arguments));
  }

  _createClass(Component, [{
    key: "render",
    value: function render() {
      var _this$props5 = this.props,
          wrappedComponent = _this$props5.wrappedComponent,
          wrappedProps = _this$props5.wrappedProps,
          children = _this$props5.children;
      return _react.default.createElement(wrappedComponent, wrappedProps, children);
    }
  }]);

  return Component;
}(_react.default.Component);

function createContainer(wrappedComponent, componentName, componentInstance, componentKey, containerEventHandlers, isTargetContainer) {
  var props = arguments.length > 6 && arguments[6] !== undefined ? arguments[6] : {};
  var nestedComponents = arguments.length > 7 && arguments[7] !== undefined ? arguments[7] : null;

  if (containerEventHandlers && containerEventHandlers.length > 0 || isTargetContainer) {
    // create a connected container only for components that participate in the flow
    var actions = (0, _actions.default)("".concat(componentName, "_").concat(componentInstance), containerEventHandlers);

    var mapDispatchToProps = function mapDispatchToProps(dispatch) {
      return {
        actions: (0, _redux.bindActionCreators)(actions, dispatch)
      };
    }; // const innerStructuresSelectorObject = {};
    // if (containerProperties && containerProperties.length > 0) {
    //   containerProperties.forEach(propertyName => {
    //     innerStructuresSelectorObject[propertyName] =
    //       createContainerSelector(componentName, componentInstance, propertyName);
    //   });
    // }


    var mapStateToProps = (0, _reselect.createStructuredSelector)({
      stateProps: (0, _selectors.default)(componentName, componentInstance)
    });
    return _react.default.createElement((0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(Container), {
      key: "container_".concat(props.key),
      componentKey: componentKey,
      componentName: componentName,
      componentInstance: componentInstance,
      containerEventHandlers: containerEventHandlers,
      wrappedProps: props,
      wrappedComponent: wrappedComponent
    }, nestedComponents);
  }

  return _react.default.createElement(Component, {
    key: "component_".concat(props.key),
    wrappedProps: props,
    wrappedComponent: wrappedComponent
  }, nestedComponents);
}