"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _forOwn = _interopRequireDefault(require("lodash/forOwn"));

var _uniqueId = _interopRequireDefault(require("lodash/uniqueId"));

var _isEmpty = _interopRequireDefault(require("lodash/isEmpty"));

var _get = _interopRequireDefault(require("lodash/get"));

var _isArray = _interopRequireDefault(require("lodash/isArray"));

var _isObject = _interopRequireDefault(require("lodash/isObject"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _ErrorBoundary = _interopRequireDefault(require("./ErrorBoundary"));

var _NotFoundComponent = _interopRequireDefault(require("../NotFoundComponent"));

var _Container = _interopRequireDefault(require("./Container"));

var _WarningComponent = _interopRequireDefault(require("../WarningComponent"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var PageComposition =
/*#__PURE__*/
function (_Component) {
  _inherits(PageComposition, _Component);

  function PageComposition(props) {
    var _this;

    _classCallCheck(this, PageComposition);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(PageComposition).call(this, props));
    _this.renderPage = _this.renderPage.bind(_assertThisInitialized(_this));
    _this.renderComponent = _this.renderComponent.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(PageComposition, [{
    key: "renderShape",
    value: function renderShape(descriptionShape) {
      var _this2 = this;

      var result = {};
      (0, _forOwn.default)(descriptionShape, function (value, prop) {
        if (value) {
          if ((0, _isArray.default)(value)) {
            result[prop] = _this2.renderArray(value);
          } else if ((0, _isObject.default)(value)) {
            if (value.type && value.instance) {
              result[prop] = _this2.renderComponent(value);
            } else {
              result[prop] = _this2.renderShape(value);
            }
          } else {
            result[prop] = value;
          }
        } else {
          result[prop] = value;
        }
      });
      return result;
    }
  }, {
    key: "renderArray",
    value: function renderArray(descriptionArray) {
      var _this3 = this;

      var result = [];

      if (descriptionArray.length > 0) {
        descriptionArray.forEach(function (descriptionItem) {
          if (descriptionItem) {
            if ((0, _isArray.default)(descriptionItem)) {
              result.push(_this3.renderArray(descriptionItem));
            } else if ((0, _isObject.default)(descriptionItem)) {
              if (descriptionItem.type && descriptionItem.instance) {
                result.push(_this3.renderComponent(descriptionItem));
              } else {
                result.push(_this3.renderShape(descriptionItem));
              }
            } else {
              result.push(descriptionItem);
            }
          } else {
            result.push(descriptionItem);
          }
        });
      }

      return result;
    }
  }, {
    key: "renderComponent",
    value: function renderComponent(description) {
      var _this4 = this;

      var _this$props = this.props,
          userComponents = _this$props.userComponents,
          actionSequences = _this$props.actionSequences,
          targets = _this$props.targets;

      if (!description) {
        return null;
      }

      var type = description.type,
          instance = description.instance,
          key = description.key,
          props = description.props,
          children = description.children;

      if (!type) {
        return null;
      }

      var propsComponents = {};

      if (props) {
        propsComponents = this.renderShape(props);
      }

      var nestedComponents = [];

      if (children && children.length > 0) {
        nestedComponents = children.map(function (child) {
          return _this4.renderComponent(child);
        });
      }

      if (propsComponents.children && (0, _isArray.default)(propsComponents.children)) {
        nestedComponents = nestedComponents.concat(propsComponents.children);
        delete propsComponents.children;
      }

      var validType = type || 'div';

      if (validType.charAt(0) === '_') {
        var pageComponentType = validType.substr(1);
        return _react.default.createElement(pageComponentType, _objectSpread({
          key: key || (0, _uniqueId.default)(validType)
        }, props, {}, propsComponents), nestedComponents);
      } else {
        // this is a user custom component, create container for it
        var wrappedComponent = (0, _get.default)(userComponents, validType, null);

        if (!wrappedComponent) {
          return _react.default.createElement(_NotFoundComponent.default, {
            key: (0, _uniqueId.default)('notFound'),
            componentName: validType
          });
        }

        var _ref = props || {},
            _doNotCreateContainer = _ref._doNotCreateContainer;

        var containerKey = "".concat(type, "_").concat(instance);

        if (_doNotCreateContainer) {
          return _react.default.createElement(wrappedComponent, _objectSpread({
            key: key || (0, _uniqueId.default)(validType)
          }, props, {}, propsComponents), nestedComponents);
        }

        var containerHandlers = [];
        var componentKey;
        var actionSequence = actionSequences[containerKey];

        if (actionSequence) {
          containerHandlers = actionSequence.events;
          componentKey = actionSequence.componentKey;
        }

        var isTargetContainer = targets[containerKey];
        return (0, _Container.default)(wrappedComponent, type, instance, componentKey, containerHandlers, isTargetContainer, _objectSpread({
          key: key || "".concat(containerKey, "_").concat((0, _uniqueId.default)('c'))
        }, props, {}, propsComponents), nestedComponents);
      }
    }
  }, {
    key: "renderPage",
    value: function renderPage() {
      var componentsTree = this.props.componentsTree;

      if (componentsTree && !(0, _isEmpty.default)(componentsTree)) {
        return this.renderComponent(componentsTree);
      }

      return _react.default.createElement(_WarningComponent.default, {
        message: "Page does not have components"
      });
    }
  }, {
    key: "render",
    value: function render() {
      return _react.default.createElement(_ErrorBoundary.default, {
        pageName: this.props.routePath
      }, this.renderPage());
    }
  }]);

  return PageComposition;
}(_react.Component);

_defineProperty(PageComposition, "propTypes", {
  userComponents: _propTypes.default.object,
  componentsTree: _propTypes.default.object,
  actionSequences: _propTypes.default.object,
  targets: _propTypes.default.object,
  routePath: _propTypes.default.string
});

_defineProperty(PageComposition, "defaultProps", {
  userComponents: {},
  componentsTree: {},
  actionSequences: {},
  targets: {},
  routePath: ''
});

var _default = PageComposition;
exports.default = _default;