"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _get = _interopRequireDefault(require("lodash/get"));

var _react = _interopRequireDefault(require("react"));

var _reactRouterDom = require("react-router-dom");

var _PageComposition = _interopRequireDefault(require("../PageComposition"));

var _WarningComponent = _interopRequireDefault(require("../WarningComponent"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PageRouter = function PageRouter(props) {
  var routes = props.routes,
      pages = props.pages,
      userComponents = props.userComponents,
      history = props.history,
      actionSequences = props.actionSequences,
      targets = props.targets;

  if (!routes || routes.length === 0) {
    return _react.default.createElement(_WarningComponent.default, {
      message: "Application does not have pages."
    });
  }

  var noMatchRoute = routes.find(function (r) {
    return r.pageName === 'noMatch';
  });
  return _react.default.createElement(_reactRouterDom.Router, {
    history: history
  }, _react.default.createElement(_reactRouterDom.Switch, null, routes.map(function (route) {
    return _react.default.createElement(_reactRouterDom.Route, {
      key: "route_".concat(route.path),
      exact: true,
      path: route.path,
      render: function render() {
        return _react.default.createElement(_PageComposition.default, {
          key: "page_".concat(route.pageName),
          userComponents: userComponents,
          componentsTree: (0, _get.default)(pages, route.pageName, {}),
          actionSequences: actionSequences,
          targets: targets,
          routePath: route.path
        });
      }
    });
  }), noMatchRoute && _react.default.createElement(_reactRouterDom.Route, {
    render: function render() {
      return _react.default.createElement(_PageComposition.default, {
        key: "page_".concat(noMatchRoute.pageName),
        userComponents: userComponents,
        componentsTree: (0, _get.default)(pages, noMatchRoute.pageName, {}),
        actionSequences: actionSequences,
        targets: targets,
        routePath: noMatchRoute.path
      });
    }
  }), _react.default.createElement(_reactRouterDom.Redirect, {
    to: "/"
  })));
};

var _default = PageRouter;
exports.default = _default;