"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _actions = _interopRequireDefault(require("../../store/actions"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var componentName = 'applicationStartWrapper';
var componentInstance = 'wrapperInstance';
var containerKey = "".concat(componentName, "_").concat(componentInstance);

var sendDebugMessage = require('../../commons/sendMessage').default;

var constants = require('../../commons/constants');

var StartWrapper =
/*#__PURE__*/
function (_React$Component) {
  _inherits(StartWrapper, _React$Component);

  function StartWrapper() {
    _classCallCheck(this, StartWrapper);

    return _possibleConstructorReturn(this, _getPrototypeOf(StartWrapper).apply(this, arguments));
  }

  _createClass(StartWrapper, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props = this.props,
          actionSequences = _this$props.actionSequences,
          store = _this$props.store;
      var containerHandlers = [];
      var componentKey;
      var actionSequence = actionSequences[containerKey];

      if (actionSequence) {
        containerHandlers = actionSequence.events;
        componentKey = actionSequence.componentKey;
      }

      if (containerHandlers.length > 0) {
        var actions = (0, _actions.default)(containerKey, containerHandlers);
        var onDidMountAction = actions['onApplicationStart'];

        if (onDidMountAction) {
          if (window.__webcodeskIsListeningToFramework && window.__sendFrameworkMessage) {
            sendDebugMessage({
              key: componentKey,
              eventType: constants.DEBUG_MSG_APPLICATION_START_EVENT,
              componentName: componentName,
              componentInstance: componentInstance,
              timestamp: Date.now()
            });
          }

          store.dispatch(onDidMountAction.apply(null, null));
        }
      }
    }
  }, {
    key: "render",
    value: function render() {
      return this.props.children;
    }
  }]);

  return StartWrapper;
}(_react.default.Component);

_defineProperty(StartWrapper, "propTypes", {
  actionSequences: _propTypes.default.object.isRequired,
  store: _propTypes.default.any.isRequired
});

var _default = StartWrapper;
exports.default = _default;