"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getDemoFiles = getDemoFiles;
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactRedux = require("react-redux");

var _history = require("history");

var _store = require("./store/store");

var _actions = require("./store/actions");

var _sequences = require("./store/sequences");

var _state = require("./store/state");

var _storage = require("./store/storage");

var _PageRouter = _interopRequireDefault(require("./components/PageRouter"));

var _StartWrapper = _interopRequireDefault(require("./components/StartWrapper"));

var _WarningComponent = _interopRequireDefault(require("./components/WarningComponent"));

var _DemoAppConfig = _interopRequireDefault(require("./components/DemoAppConfig"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var constants = require('./commons/constants');

var ComponentComposer = require('./components/ComponentComposer/ComponentComposer').default;

var PageComposer = require('./components/PageComposer/PageComposer').default;

var initStore = function initStore(pages, name, version) {
  var initialState = (0, _state.createInitialState)(pages);
  var history = (0, _history.createBrowserHistory)();
  var store = (0, _store.configureStore)(initialState, {
    history: history
  }, {
    name: name,
    version: version
  });

  window.__sendFrameworkMessage = function (message) {
    if (message) {
      window.parent.postMessage(message, '*');
    }
  }; // Listen for changes to the current location.


  history.listen(function (location) {
    // location is an object like window.location
    window.__sendFrameworkMessage({
      type: constants.FRAMEWORK_MESSAGE_CHANGE_URL,
      payload: "".concat(location.pathname).concat(location.search).concat(location.hash)
    });
  });
  return {
    store: store,
    history: history
  };
};

function getDemoFiles(_ref) {
  var schema = _ref.schema,
      settings = _ref.settings;
  var newFiles = {
    schema: schema,
    settings: settings
  };
  return (0, _storage.getSchema)().then(function (schemaFromStorage) {
    if (schemaFromStorage) {
      newFiles.schema = schemaFromStorage;
    }

    return (0, _storage.getSettings)();
  }).then(function (settingsFromStorage) {
    if (settingsFromStorage) {
      newFiles.settings = settingsFromStorage;
    }

    return newFiles;
  }).catch(function (error) {
    console.error(error.message);
    return newFiles;
  });
}

var Application =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Application, _React$Component);

  function Application() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, Application);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(Application)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "handleReceiveMessage", function (event) {
      var message = event.data;

      if (message) {
        var type = message.type,
            payload = message.payload;

        if (type === constants.WEBCODESK_MESSAGE_START_LISTENING_TO_FRAMEWORK) {
          window.__webcodeskIsListeningToFramework = true;
          setTimeout(function () {
            window.__sendFrameworkMessage({
              type: constants.FRAMEWORK_MESSAGE_INIT_DEBUG,
              payload: {
                actionSequences: _this.actionSequences
              }
            });
          }, 0);
        } else if (type === constants.WEBCODESK_MESSAGE_STOP_LISTENING_TO_FRAMEWORK) {
          window.__webcodeskIsListeningToFramework = false;
        } else if (type === constants.WEBCODESK_MESSAGE_SAVE_DEMO_FILES && payload) {
          var schema = payload.schema,
              settings = payload.settings;
          (0, _storage.saveSchema)(schema).then(function () {
            return (0, _storage.saveSettings)(settings);
          }).then(function () {
            window.__sendFrameworkMessage({
              type: constants.FRAMEWORK_MESSAGE_DEMO_FILES_SAVED
            });
          }).catch(function (error) {
            console.error(error.message);

            window.__sendFrameworkMessage({
              type: constants.FRAMEWORK_MESSAGE_DEMO_FILES_SAVED
            });
          });
        }
      }
    });

    return _this;
  }

  _createClass(Application, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      window.addEventListener("message", this.handleReceiveMessage, false);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      window.removeEventListener("message", this.handleReceiveMessage);
    }
  }, {
    key: "render",
    value: function render() {
      var userComponents = this.props.userComponents;
      var href = window.location.href;

      if (href.indexOf('/webcodesk__component_view') > 0) {
        return _react.default.createElement(ComponentComposer, {
          userComponents: userComponents
        });
      } else if (href.indexOf('/webcodesk__page_composer') > 0) {
        return _react.default.createElement(PageComposer, {
          userComponents: userComponents
        });
      } else if (href.indexOf('/webcodesk__demo_app_config') > 0) {
        return _react.default.createElement(_DemoAppConfig.default, null);
      }

      var _this$props = this.props,
          schema = _this$props.schema,
          userFunctions = _this$props.userFunctions,
          name = _this$props.name,
          version = _this$props.version;
      var routes, pages, flows;

      if (schema) {
        routes = schema.routes;
        pages = schema.pages;
        flows = schema.flows;
      }

      var _initStore = initStore(pages, name, version),
          store = _initStore.store,
          history = _initStore.history;

      if (!store) {
        return _react.default.createElement(_WarningComponent.default, {
          message: "Redux store is not initialized."
        });
      }

      window.__applicationBrowserHistory = history;
      (0, _actions.clearActionsCache)();

      var _createActionSequence = (0, _sequences.createActionSequences)(flows, userFunctions),
          actionSequences = _createActionSequence.actionSequences,
          targets = _createActionSequence.targets; // store action sequences and components properties in case we have to send them for debug


      this.actionSequences = actionSequences;
      return _react.default.createElement(_reactRedux.Provider, {
        store: store
      }, _react.default.createElement(_StartWrapper.default, {
        actionSequences: actionSequences,
        store: store
      }, _react.default.createElement(_PageRouter.default, {
        history: history,
        routes: routes,
        pages: pages,
        userComponents: userComponents,
        actionSequences: actionSequences,
        targets: targets
      })));
    }
  }]);

  return Application;
}(_react.default.Component);

var _default = Application;
exports.default = _default;