"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.createContainerSelector = void 0;

var _reselect = require("reselect");

var select = function select(componentName, componentInstance) {
  return function (state, props) {
    var instanceState = state["".concat(componentName, "_").concat(componentInstance)];

    if (instanceState) {
      if (props) {
        if (typeof instanceState !== 'undefined') {
          return instanceState;
        }

        return props.wrappedProps;
      } else {
        return instanceState;
      }
    } else if (props) {
      return props.wrappedProps;
    }

    return undefined;
  };
};

var createContainerSelector = function createContainerSelector(componentName, componentInstance) {
  return (0, _reselect.createSelector)(select(componentName, componentInstance), function (a) {
    return a;
  });
};

exports.createContainerSelector = createContainerSelector;
var _default = createContainerSelector;
exports.default = _default;