"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.initStorage = initStorage;
exports.getStorageInstance = getStorageInstance;
exports.getSchema = getSchema;
exports.saveSchema = saveSchema;
exports.getSettings = getSettings;
exports.saveSettings = saveSettings;

var _localforage = _interopRequireDefault(require("localforage"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
 *    Copyright 2019 Alex (Oleksandr) Pustovalov
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */
var storageInstance;

function initStorage() {
  _localforage.default.config({
    name: 'wcdDemoApp'
  });
}

function getStorageInstance() {
  if (!storageInstance) {
    initStorage();
    storageInstance = _localforage.default.createInstance({
      name: 'commonStorage'
    });
  }

  return storageInstance;
}

function getSchema() {
  return regeneratorRuntime.async(function getSchema$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          return _context.abrupt("return", getStorageInstance().getItem('schema'));

        case 1:
        case "end":
          return _context.stop();
      }
    }
  });
}

function saveSchema(schema) {
  return regeneratorRuntime.async(function saveSchema$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          return _context2.abrupt("return", getStorageInstance().setItem('schema', schema));

        case 1:
        case "end":
          return _context2.stop();
      }
    }
  });
}

function getSettings() {
  return regeneratorRuntime.async(function getSettings$(_context3) {
    while (1) {
      switch (_context3.prev = _context3.next) {
        case 0:
          return _context3.abrupt("return", getStorageInstance().getItem('settings'));

        case 1:
        case "end":
          return _context3.stop();
      }
    }
  });
}

function saveSettings(settings) {
  return regeneratorRuntime.async(function saveSettings$(_context4) {
    while (1) {
      switch (_context4.prev = _context4.next) {
        case 0:
          return _context4.abrupt("return", getStorageInstance().setItem('settings', settings));

        case 1:
        case "end":
          return _context4.stop();
      }
    }
  });
}