"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.configureStore = configureStore;

var _redux = require("redux");

var _reduxThunk = _interopRequireDefault(require("redux-thunk"));

var _reducer = _interopRequireDefault(require("./reducer"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var developmentOnly = require('redux-devtools-extension/developmentOnly');

var composeWithDevTools = developmentOnly.composeWithDevTools;

function configureStore(initialState, helpersConfig, _ref) {
  var name = _ref.name,
      version = _ref.version;
  var middleware = [_reduxThunk.default.withExtraArgument(helpersConfig)];
  var enhancer; // https://github.com/zalmoxisus/redux-devtools-extension#14-using-in-production

  var composeEnhancers = composeWithDevTools({
    // Options: https://github.com/zalmoxisus/redux-devtools-extension/blob/master/docs/API/Arguments.md#options
    name: "".concat(name, "@").concat(version)
  }); // https://redux.js.org/docs/api/applyMiddleware.html

  enhancer = composeEnhancers(_redux.applyMiddleware.apply(void 0, middleware)); // https://redux.js.org/docs/api/createStore.html

  return (0, _redux.createStore)(_reducer.default, initialState, enhancer);
}